﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
#End Region

Sub Process_Globals
	Public mqttlog As String							' flag to stog log of MQTT messages
	Public mqttmessage As Boolean = False				' true = new lessage received
		Public mqttalarm As Boolean = False					'true = new alarm to highlignt
		Public mqttstatus As String = "MQTT not connected"
	Public mqttworking As Boolean = False           	'start of MQTT after config loaded
	Private nid As Int = 1
	Private mqtt As MqttClient
	Private lock As PhoneWakeState
	Private playID1,loadid1 As Int
	Private timer1 As Timer
	Private mqttlimit As Int = 0						' limit of ringing 10 * 9sec 
	Private sp  As SoundPool
	Private mqttserver As String = "tcp:\\cloudmqtt.com"
	Private mqttport As String = "1234"
	Private mqttuser As String = "user"
	Private mqttpwd As String  = "pwd"
	Private mqttsubs As String = "subscribe"
	Private SOScode1 As String = "654321"
	Private SOScode2 As String = "123456"
	Private SOSsound As String = "8499.mp3"
	Private fulllog As String = "SOS"					' flag to add in log only SOS alarm messages or all
'	Private serializator As B4XSerializator
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	Service.StartForeground(nid, CreateNotification("..."))
	lock.PartialLock
	sp.Initialize(1)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground

	ConnectAndReconnect
End Sub

Sub ConnectAndReconnect
	Do While True
 	service_loadconfig
	Do While mqttworking
		If mqtt.IsInitialized Then mqtt.Close
'		Log(mqttserver&":"&mqttport)
		mqtt.Initialize("mqtt",(mqttserver&":"&mqttport), Rnd(0, 999999999 & DateTime.Now))
		Dim mo As MqttConnectOptions
		mo.Initialize(mqttuser, mqttpwd)
		Log("Trying to connect")
		mqttstatus ="Trying to connect"
		mqtt.Connect2(mo)
		Wait For mqtt_Connected (Success As Boolean)
		If Success Then
			Log("Mqtt connected")
			mqttstatus = "MQTT connected"
			mqtt.Subscribe(mqttsubs, 0)
'		mytopic = "drawers/" & mqtt.ClientId
			Do While mqttworking And mqtt.Connected
				mqtt.Publish2("ping", Array As Byte(0), 1, False) 'change the ping topic as needed
				Sleep(5000)
			Loop
			Log("Disconnected")
			mqttstatus = "MQTT disconnected"
		Else
			Log("Error connecting.")
			Log(LastException)
			mqttstatus = "error MQTT connecting"
		End If
		Sleep(5000)
	Loop
	Loop
End Sub

Sub mqtt_Connected (Success As Boolean)

End Sub

Sub mqtt_Disconnected
	'mqttstatus = "MQTT disconnected"
End Sub

public Sub mqtt_publish     '(topic As String,body As String)
	Dim payload() As Byte
	Dim topic, body As String
	topic = "cmnd/rfbridge/backlog"
	body = "RfSync 11370; RfLow 390; RfHigh 1110; RfCode #F17777"
	'exemple of command to sent to rf bridge sonoff and to 433mhz relay
   	payload = body.getbytes("UTF8")
   	If mqtt.Connected = True Then 
    	mqtt.Publish(topic, payload)	
	End If	
End Sub

'exemple of reception from RF bridge sonoff with tasmota:
'	{"Time":"2020-01-13T11:49:06","RfReceived":{"Sync":14650,"Low":350,"High":1480,"Data":"755555","RfKey":"None"}}
'   {"Time":"2020-01-13T12:48:14","RfReceived":{"Sync":15600,"Low":530,"High":1530,"Data":"4D2222","RfKey":"None"}}
'   {"Time":"2020-01-13T13:08:40","RfReceived":{"Sync":11370,"Low":390,"High":1110,"Data":"F17777","RfKey":"None"}}

Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
'	Dim obj As Object = serializator.ConvertBytesToObject(Payload)
	Dim s As String =BytesToString(Payload,0,Payload.Length,"UTF-8")
'	Log(Topic)
'	Log(s)
	If s.Contains(SOScode1) Or s.Contains(SOScode2) Then
		mqttalarm = True
		Dim n As Notification = CreateNotification(s)
		n.Notify(nid)
		timer1.Initialize("timer1", 9000)
		timer1.Enabled = True
		mqttlimit = 10
		
		playID1=sp.Play(loadid1,1, 1, 1, 0, 1)
		Service.StartForeground(nid,CreateNotification("time"&(s.SubString2(7,30))&" SOS"&( s.SubString2(85,94))))
	End If
  	If (fulllog <> "SOS") Or (mqttalarm = True) Then
		If (mqttlog.Length > 3400) Then mqttlog = mqttlog.SubString(mqttlog.IndexOf(Chr(10))+1)
		' we remove one line at log file
		mqttlog= mqttlog & CRLF & s
		mqttmessage = True
	End If
End Sub

Public Sub Play
	Service.StartForeground(nid, CreateNotification("Tracking ON"))
End Sub

 Sub service_loadconfig
	If File.Exists(File.DirInternal,"config.txt") Then
		Dim tr As TextReader
		Dim line As String
		tr.Initialize2(File.OpenInput(File.Dirinternal, "config.txt"), "UTF-8" )
		mqttserver = tr.ReadLine: If line <> "" Then mqttserver = line
		line = tr.readline: If line <> "" Then mqttport= line
		line = tr.ReadLine: If line <> "" Then mqttuser = line
		line = tr.ReadLine: If line <> "" Then mqttpwd = line
		line = tr.ReadLine: If line <> "" Then mqttsubs = line
		line = tr.ReadLine: If line <> "" Then SOScode1 = line
		line = tr.ReadLine: If line <> "" Then SOScode2 = line
		line = tr.ReadLine: If line <> "" Then SOSsound = line
		line = tr.ReadLine: If line <> "" Then fulllog = line
		mqttworking = True
	Else
		mqttworking = False
	End If
	If Not (File.Exists(File.DirAssets,SOSsound)) Then SOSsound = "8499.mp3"
	loadid1=sp.Load(File.DirAssets,SOSsound)   
'	Log("loading player:" & SOSsound & " | " & fulllog)
End Sub

Sub Timer1_Tick     
	'if no action on button, ringing will continue for 10 times
	mqttlimit = mqttlimit -1
	If mqttlimit < 1 Then mqttalarm = False
	If mqttalarm = False Then
		timer1.Enabled = False
	Else
		playID1=sp.Play(loadid1,1, 1, 1, 0, 1)
	End If
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Tracking SOS Alertes", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	mqttstatus = "MQTT not connected"
	lock.ReleasePartialLock
End Sub
